#include "pm.h"
#include "lift.h"

#ifdef DUMB
DUH *myduh;
AL_DUH_PLAYER *dp;
#endif

extern char global_string[20][25][80]; // menu.c
int num_lifts;
struct lift *lifts[20];
struct lift_step *lift_steps[20][20];
struct player players[NUM_PLAYERS];

// timer variables
volatile int timer_passcount = 0;
volatile int last_fps_passcount = 0;
volatile int fps;
int frames_skipped = 0;
int sync_adjust = 0; // unless changed by client

char fnlst[50][80]; // for autoplay
int fn = 0;

char eitype_desc[50][32][40];
int e_killed_type;

int pm_bullet_collision_box = 8;
int map_on=0;

// other global variables

BITMAP *memory_bitmap[NUM_SPRITES];
BITMAP *level_2000, *scrn_buffer;
BITMAP *map100_bmp, *map100_bkg;
BITMAP *dtemp; // temp draw
PALLETE pallete;

SAMPLE *snd[20];

int lines[50][6];
float y_adj=0;
int tmx, tmy;   // menu pos
int tmtx, tmty; // text position
int mx, my, md, map_double;
float steps;
int num_sounds;
int lit_item;
int fuse_loop_playing;
int sample_delay[8];
int bcmt[NUM_SPRITES];
int sa[NUM_SPRITES][2];

int sx=640;
int sy=480;

int level_num;
char level_filename[20];

int old_tf;
int oac;

int level_header[20];
int l[100][100];    // level
int item[500][16];  // items
char *pmsg[500];
int Ei[100][32];    // enemies
float Ef[100][16];  // enemies

int zz[20][NUM_ANS];
int passcount;
int draw_frame;
int no_draw_till_passcount = 0;
int control_lead_frames = 0;

int speed;
int play_level;
int start_mode = 1;

int resume_allowed=0;
int top_menu_sel = 3;
int level_time;
int LIVES;

int start_level=1;
int sound_on = 0;
int passcount_timer_fps= 20;

int max_bullets = 200;
int pbullet[50][6];

int e_bullet_active[50], e_bullet_shape[50];
int enemy_bullet_colision_window = 2;
float e_bullet_x[50], e_bullet_y[50], e_bullet_xinc[50], e_bullet_yinc[50];

int bomb[20][5];

float itemf[500][4];

int level_done = 0;
int game_exit = 0;
int num_enemy;

// counters and temp string
char b_msg[40][80];
int bottom_msg=0;
int pop_msg=0;
int pop_msg_count;

int map100_x = 0, map100_y = 20;
int game_map_on=0, top_display_on = 1;
int top_display_x, top_display_y=0, top_display_color=240;
int bottom_display_y=186, bottom_display_color=240;

int map_solid_color = 240, map_semi_color = 3;
int map_break_color = 12, map_empty_color = 241;
int map_enemy_color=5 , map_bullet_color= 14;
int map_item_color=11, map_player_color = 8;
int edit_int_retval;

char scantext[127][80];


void inc_timer_passcount()
{
   timer_passcount++;
}
END_OF_FUNCTION(inc_timer_passcount);

void second_timer()
{
   fps = passcount - last_fps_passcount;
   last_fps_passcount = passcount;
}
END_OF_FUNCTION(second_timer);


void maps_and_background_fill()
{
   int c,d,x,y;
   clear(map100_bmp);
   clear(map100_bkg);
   clear(scrn_buffer);

   for (c=0; c < 500; c++) /* set all of itemf[500][4] to 0 */
      for(y=0; y<4; y++)
         itemf[c][y] = 0;

   for (x=0; x<500; x++)
      if (item[x][0]) /* only if active set float x y */
      {
         itemf[x][0] = item[x][4];
         itemf[x][1] = item[x][5];
      }

   for (x = 0; x < 20; x++)
      for (y = 0; y < 5; y++)
         bomb[x][y] = 0;


   for (d=0; d<level_header[5]; d++)
      {
         lifts[d]->fx = lift_steps[d][0] -> x; /* set float x */
         lifts[d]->fy = lift_steps[d][0] -> y; /* set float y */
         lifts[d]->fxinc = 0; /* set float xinc */
         lifts[d]->fyinc = 0; /* set float yinc */

         lifts[d]->current_step = 0;  /* mode 0  */
         lifts[d]->limit_type = 5;  /* type wait for time   */
         lifts[d]->limit_counter = 0;  /* 0 = no wait! immediate next mode  */
      }

   for (x=0; x<100; x++) /* fill maps and background */
      for (y=0; y<100; y++)
         {
            c = l[x][y];
            if (c<NUM_SPRITES) blit(memory_bitmap[c], level_2000, 0, 0, x*20, y*20, 20, 20);
            if (c == 169) blit(memory_bitmap[0], level_2000, 0, 0, x*20, y*20, 20, 20);
         }

   stretch_blit(level_2000, map100_bkg, 0, 0, 2000, 2000, 0, 0, 100, 100);
   draw_lift_lines();

   for (x=0; x<100; x++) /* finish map */
      for (y=0; y<100; y++)
         {
            c = l[x][y];

            putpixel(map100_bkg, x, y, bcmt[c]);


            if (c == 169)
               putpixel(map100_bkg, x, y, 0 ); /* translucency mask */

            if (c == 0)
               putpixel(map100_bkg, x, y, 241 ); /* empty not masked */

         }

   players[0].jump_count=0;
   players[0].fall_count=0;
   for (c = 0; c < 50; c++)
      {
         e_bullet_xinc[c] = 0;
         e_bullet_yinc[c] = 0;
         e_bullet_y[c] = 0;
         e_bullet_x[c] = 0;
         e_bullet_active[c] = 0;
         e_bullet_shape[c] = 0;
         pbullet[c][0] = 0;
         pbullet[c][1] = 0;
         pbullet[c][2] = 0;
         pbullet[c][3] = 0;
         pbullet[c][4] = 0;
         pbullet[c][5] = 0;
      }
}
void sc_setup(void) // screen change final wrap up and initial setup
{
   int c,x,y;
   top_display_x = (SCREEN_W/2)-95;

   /* clean up old bitmaps */
   for (c=0; c<NUM_SPRITES; c++)
      destroy_bitmap(memory_bitmap[c]);
   destroy_bitmap(map100_bmp);
   destroy_bitmap(map100_bkg);
   destroy_bitmap(level_2000);
   destroy_bitmap(scrn_buffer);

   /* create new bitmaps  */
   for (c=0; c<NUM_SPRITES; c++)
      memory_bitmap[c] = create_bitmap(20,20);
   scrn_buffer = create_bitmap(SCREEN_W,SCREEN_H);
   level_2000 = create_bitmap(2000,2000);
   map100_bkg = create_bitmap(100,100);
   map100_bmp = create_bitmap(100,100);

   load_sprit();

   /* set the pass counters in the animation seqs */
   set_zz(passcount);

   for (x=0; x<100; x++) /* fill maps and background */
   for (y=0; y<100; y++)
   {
      c = l[x][y];
      if (c<NUM_SPRITES) blit(memory_bitmap[c], level_2000, 0, 0, x*20, y*20, 20, 20);
      if (c == 169) blit(memory_bitmap[0], level_2000, 0, 0, x*20, y*20, 20, 20);
   }

   stretch_blit(level_2000, map100_bkg, 0, 0, 2000, 2000, 0, 0, 100, 100);
   set_map_var();
   set_screens(0);
   draw_lift_lines();

   for (x=0; x<100; x++) /* finish map */
      for (y=0; y<100; y++)
         {
            c = l[x][y];

            putpixel(map100_bkg, x, y, bcmt[c]);

            if (c == 169)
               putpixel(map100_bkg, x, y, 0 ); /* masked */

            if (c == 0)
               putpixel(map100_bkg, x, y, 241 ); /* empty not masked */
         }

}
void final_wrapup(void)
{
   int c;

   for (c=0; c<NUM_SPRITES; c++)
      destroy_bitmap(memory_bitmap[c]);
   destroy_bitmap(map100_bmp);
   destroy_bitmap(map100_bkg);
   destroy_bitmap(level_2000);
   destroy_bitmap(scrn_buffer);
   destroy_bitmap(dtemp);




#ifdef SOUND
   for (c=0; c<num_sounds; c++)
      destroy_sample(snd[c]);
#endif
#ifdef DUMB
   al_stop_duh(dp);
   unload_duh(myduh);
   dumb_exit();
#endif

   allegro_exit();
}

int initial_setup(void)
{
   int c, x, y;

   allegro_init();


   if (os_type == OSTYPE_LINUX)
   {
      printf("linux detected\n\n");
   }
   if (os_type == OSTYPE_WINXP)
   {
      printf("windows XP detected\n\n");
   }

   install_keyboard();
   install_timer();
   install_mouse();

   // srandom(time(NULL));  // random seed from timer
   menu_setup(); // load a bunch of text

   // get screen size from config file, with defaults if none found
   sx = get_config_int("GAME", "sx", 640);
   sy = get_config_int("GAME", "sy", 480);

   sprintf(global_string[8][5], "Screen Mode:%dx%d",sx, sy);
   if (set_gfx_mode(GFX_AUTODETECT, sx, sy, 0,0))
   {
      sx = 640;
      sy = 480;
      set_config_int("GAME", "sx", sx);
      set_config_int("GAME", "sy", sy);
      if (!set_gfx_mode(GFX_AUTODETECT, sx, sy, 0,0)) return 0;
   }

   top_display_x = (SCREEN_W/2)-95;
   show_mouse(NULL);
   set_map_var();

   players[0].active = 1;
   players[0].paused = 0;
   players[0].local_draw = 1;
   players[0].initial_x_speed=1.15;
   players[0].max_x_speed=4;
   players[0].right_speed=0;
   players[0].left_speed=0;
   players[0].p_xmove=0;
   players[0].accel=.06;
   players[0].de_accel=.3;
   players[0].left_right=0;
   players[0].jump_count=0;
   players[0].fall_count=0;
   players[0].jump_sinc=.05,
   players[0].fall_sinc = 0.1;
   players[0].pmovey = 5;
   players[0].ex_jump = 0;
   players[0].player_carry = 0;

   players[0].bullet_wait_counter=0;
   players[0].request_bullet = 0;
   players[0].bullet_wait = 5;
   players[0].bullet_speed = 12;
   players[0].num_bullets = 100;

   players[0].LIVES = 5;
   players[0].LIFE = 100;
   players[0].num_bullets = 200;
   players[0].num_hits = 0;


   players[1].active = 0;
   players[1].paused = 0;
   players[1].local_draw = 1;
   players[1].initial_x_speed=1.15;
   players[1].max_x_speed=4;
   players[1].right_speed=0;
   players[1].left_speed=0;
   players[1].p_xmove=0;
   players[1].accel=.06;
   players[1].de_accel=.3;
   players[1].left_right=0;
   players[1].jump_count=0;
   players[1].fall_count=0;
   players[1].jump_sinc=.05,
   players[1].fall_sinc = 0.1;
   players[1].pmovey = 5;
   players[1].ex_jump = 0;
   players[1].player_carry = 0;

   players[1].bullet_wait_counter=0;
   players[1].request_bullet = 0;
   players[1].bullet_wait = 5;
   players[1].bullet_speed = 12;
   players[1].num_bullets = 100;

   players[1].LIVES = 5;
   players[1].LIFE = 100;
   players[1].num_bullets = 200;
   players[1].num_hits = 0;

   set_screens(0);

   erase_autoplay(0);
   erase_autoplay(1);

#ifdef SOUND
   // get sound status
   sound_on = get_config_int("GAMECONTROLS", "sound_on", 0);
   if (sound_on)
      load_sound(); //  normal load
#else
   sound_on = 0;
#endif


#ifdef DUMB
   dumb_register_stdfiles();
   myduh = dumb_load_xm("snd/pm.xm");
#endif


    // get speed
   speed = get_config_int("GAMECONTROLS", "speed", 2);
   set_speed();

   set_start_level(start_level);

   if (load_joystick_data(NULL))
   {
      textout_centre(screen, font, "Unable to load joystick data",SCREEN_W/2, SCREEN_H/2, 13);
      rest(1500);
      if (install_joystick(JOY_TYPE_AUTODETECT))
      {
         textout_centre(screen, font, "Unable to install joystick",SCREEN_W/2, SCREEN_H/2+8, 13);
         rest(1500);
      }
   }
   load_keys();

   LOCK_VARIABLE(timer_passcount);
   LOCK_FUNCTION(inc_timer_passcount);

   LOCK_VARIABLE(fps);
   LOCK_VARIABLE(last_fps_passcount);

   LOCK_FUNCTION(second_timer);



   // this is for the fps
   install_int_ex(second_timer, BPS_TO_TIMER(1));

   // animation initial zeroing
   for (x=0; x<20; x++)
      for (c=0; c<NUM_ANS; c++)
         zz[x][c] = 0;

   for (c=0; c < 100; c++) // zero enemies
      for (y=0; y < 10; y++)
      {
         Ef[c][y] = 0;
         Ei[c][y] = 0;
      }
   for (c=0; c<100; c++) // set all of l[100][100] to 0
      for (y=0; y<100; y++)
         l[c][y]=0;

   for (c=0; c < 500; c++) // set all of itemf[500][4] to 0
      for(y=0; y<4; y++)
         itemf[c][y] = 0;
   for (c=0; c < 500; c++) // set all of item[500][16] to 0
      for (y=0; y < 16; y++)
         item[c][y]=0;

   for (c = 0; c < NUM_SPRITES; c++)
      bcmt[c] = 0;

   for (c=0; c<NUM_SPRITES; c++)
   {
      memory_bitmap[c] = create_bitmap(20,20);
      clear(memory_bitmap[c]);
   }
   level_2000 = create_bitmap(2000,2000);
   scrn_buffer = create_bitmap(SCREEN_W,SCREEN_H);
   map100_bkg = create_bitmap(100,100);
   map100_bmp = create_bitmap(100,100);
   dtemp = create_bitmap(20,20);

   if (!load_sprit())
   {
      textout_centre(screen, font, "Error loading sprit file...Exiting",SCREEN_W/2, (SCREEN_H/2)-10, 2);
      rest(1000);
      return 0;
   }
   set_zz(0); /* zero the pass counters in the animation seqs */
   maps_and_background_fill();
   clear(screen);
   return 1;
}

int menu_down_check (void)
{
   proc_controllers();
   if ((key[KEY_DOWN]) || (players[0].down) || (players[1].down) )
      return 1;
   else return 0;
}
int menu_up_check (void)
{
   proc_controllers();
   if ((key[KEY_UP]) || (players[0].up) || (players[1].up) )
      return 1;
   else return 0;
}

int main(int argument_count, char **argument_array)
{
   int x;
   if (initial_setup())
   {
//      int quit = 0;
      char exe_pathandfile[80];
      char *exe_file;
      sprintf(exe_pathandfile, "%s",argument_array[0]);
      int exe_pathandfile_len = strlen(exe_pathandfile);
      exe_file = get_filename(exe_pathandfile);
      int exe_file_len = strlen(exe_file);
      int nl = exe_pathandfile_len - exe_file_len;
      exe_pathandfile[nl]=0;
      if (argument_count == 2)
         start_level = atoi(argument_array[1]);
      else
         start_level = 1;
      slow_load_and_draw_level(start_level);
      set_start_level(start_level);
      do
      {
         frame_and_title();
         draw_level();
         top_menu_sel = zmenu(7, top_menu_sel, tmy);

         if (top_menu_sel == 2) // start level
         {
            char msg[80];
            int old_mouse;
            int old_start_level = -1;
            int quit = 0;
            start_mode = 1;
            while (key[KEY_ENTER]);
            while (mouse_b&1);
            //  while (joy_b1) poll_joystick(); // wait for release
            while (!quit)
            {
               resume_allowed = 0;
               // if (joy_key) poll_joystick();
               sprintf(msg, " (%d) " ,start_level );
               // make it red
               textout(screen, font, msg, -(8*(strlen(msg)-1)) + tmx + (strlen(global_string[7][2])*8) / 2, tmy+16, 10);
               if (menu_up_check())
               {
                  if (++start_level > 199) start_level=199;
                  while (menu_up_check());
               }
               if (menu_down_check())
               {
                  if (--start_level < 1) start_level=1;
                     while (menu_down_check());
               }
               position_mouse(160,100);
               old_mouse = mouse_y;
      
               // show start level here
               if (old_start_level != start_level)
               {
                  old_start_level = start_level;
                  slow_load_and_draw_level(start_level);
                  old_mouse = mouse_y; // to make it easier to stay on a certain level
               }
               else rest(10);
               if (mouse_y > old_mouse) if (--start_level < 1) start_level=1;
               if (mouse_y < old_mouse) if (++start_level > 199) start_level = 199;

               if (key[KEY_ESC]) quit = 1;
               if (key[KEY_ENTER]) quit = 1;
               if ((mouse_b&1) || (mouse_b&2)) quit = 1;
               if (players[0].fire || players[1].fire) quit = 1;
               if (players[0].jump || players[1].jump) quit = 1;
            } // end of while ! quit
            while ((key[KEY_ESC]) || (key[KEY_ENTER]));
            while ((mouse_b&1) || (mouse_b&2));
            while (joy_b1) poll_joystick(); // wait for release
            top_menu_sel = 3;               // change to START LEVEL
            set_start_level(start_level);
         }

         // this must be before 3 because sometimes 3 calls 4 immed
         if ((top_menu_sel == 4) && (resume_allowed)) // resume game
         {
            start_mode = 0;
            game_exit = 0;

#ifdef DUMB
            start_music();
#endif

            pm_main();
         }

         if (top_menu_sel == 3) // start game
         {
            no_draw_till_passcount = 0;

            // set to single screen by default
            set_screens(0);
            // set to split if both active
            if (players[0].active && players[1].active)
            {
               set_screens(2);
            }

            int p;
            for (p=0; p<NUM_PLAYERS; p++)
               if (players[p].active)
               {
                  players[p].num_bullets = 200;
                  players[p].LIFE = 100;
                  players[p].LIVES = 5;
//                  players[p].num_hits = 0; let this add up !!

               }

            level_done = 0;
            play_level = start_level;
            start_mode = 1; // load level and start
            game_exit = 0;
            pm_main();
         }

/*

         if (top_menu_sel == 5) // load game
         {
            load_apl(0);


            // set to single screen by default
            set_screens(0);
            // set to split if both active
            if (players[0].active && players[1].active)
            {
               set_screens(2);
            }

       //     printf("last_api:%d - %d\n", last_api, autoplay[last_api-1][0]);

//            no_draw_till_passcount = autoplay[last_api-1][0];

            int p;
            for (p=0; p<NUM_PLAYERS; p++)
            if (players[p].active)
            {
               players[p].control_method = 1;
               players[p].LIVES = 5;
            }

            game_exit = 0;
            start_mode = 1;  // load level mode
            pm_main();
            resume_allowed = 1;

            for (p=0; p<NUM_PLAYERS; p++)
               if (players[p].active)
               {
                  players[p].control_method = 0;
               }
         }
         if (top_menu_sel == 6) // save game
         {
            save_apl();
         }
         if (top_menu_sel == 7) // run game
         {
            int old_start_level = start_level;
            int p;
            load_apl(0);

            // set to single screen by default
            set_screens(0);
            // set to split if both active
            if (players[0].active && players[1].active)
            {
               set_screens(2);
            }

            for (p=0; p<NUM_PLAYERS; p++)
               if (players[p].active)
               {
                  players[p].control_method = 1;
                  players[p].LIVES = 5;
               }
            game_exit = 0;
            start_mode = 1;  // load level mode
            pm_main();
            resume_allowed = 0;
            set_start_level(old_start_level);
            slow_load_and_draw_level(start_level);

            for (p=0; p<NUM_PLAYERS; p++)
               if (players[p].active)
               {
                  players[p].control_method = 0;
               }
         }


         if (top_menu_sel == 12)
         {
            clear_keybuf();
            demo_mode();
         }

         if (top_menu_sel == 666) // start 2 player game
         {
            no_draw_till_passcount = 0;
            players[0].active = 1;
            players[0].paused = 0;
            players[1].active = 1;
            players[1].paused = 0;
            set_screens(2);
            int p;
            for (p=0; p<2; p++)
            {
               players[p].num_bullets = 200;
               players[p].LIFE = 100;
               players[p].LIVES = 5;
            }
            level_done = 0;
            play_level = start_level;
            start_mode = 1; // load start
            game_exit = 0;
            pm_main();
         }


*/

         if (top_menu_sel == 5) // player 1 controller setup menu
         {
            int p1_menu_sel = 2;
            do
            {
               clear(screen);
               frame_and_title();
               p1_menu_sel = zmenu(9,p1_menu_sel,50);
               if (p1_menu_sel == 3)
               {
                  players[0].active = 1;
                  players[0].paused = 0;
               }
               if (p1_menu_sel == 4)
               {
                  players[0].active = 0;
                  players[0].paused = 0;
               }
               if (p1_menu_sel == 5)
               {
                  get_all_keys(0);
               }
               if (p1_menu_sel == 6)
               {
                  get_one_key(0);
               }
            }  while (p1_menu_sel != 2); // end of player control menu
            rest(100);
            clear(screen);
         }

         if (top_menu_sel == 6) // player 2 controller setup menu
         {
            int p2_menu_sel = 2;
            do
            {
               clear(screen);
               frame_and_title();
               p2_menu_sel = zmenu(10,p2_menu_sel,50);
               if (p2_menu_sel == 3)
               {
                  players[1].active = 1;
                  players[1].paused = 0;
               }
               if (p2_menu_sel == 4)
               {
                  players[1].active = 0;
                  players[1].paused = 0;
               }
               if (p2_menu_sel == 5)
               {
                  get_all_keys(1);
               }
               if (p2_menu_sel == 6)
               {
                  get_one_key(1);
               }
            }  while (p2_menu_sel != 2); // end of player control menu
            rest(100);
            clear(screen);
         }


         if (top_menu_sel == 8) help(0); // help
         if (top_menu_sel == 7) // options menu
         {
            int options_menu_sel = 2;
            do
            {
               clear(screen);
               frame_and_title();
               options_menu_sel = zmenu(8,options_menu_sel,50);

               if (options_menu_sel == 3) // speed
               {
                  if (++speed > 5) speed = 1;
                  set_speed();
               }
               if (options_menu_sel == 4) // sound
               {
#ifdef SOUND
                  sound_setup();
#endif
               }
               if (options_menu_sel == 5) // set screen mode
               {
                  int card = GFX_AUTODETECT;
                  int w = sx;
                  int h = sy;
                  int color_depth = 8;
                  if (gfx_mode_select_ex(&card, &w, &h, &color_depth))
                     if (set_gfx_mode(card, w, h, 0, 0) < 0)
                     {
                        set_gfx_mode(GFX_AUTODETECT, sx, sy, 0, 0);
                        sc_setup();
                        gui_fg_color = 255;
                        gui_mg_color = 8;
                        gui_bg_color = 0;
           	            alert("Error setting mode:", allegro_error, NULL, "Sorry", NULL, 13, 0);
                     }
                     else
                     {
                        sx = w;
                        sy = h;
                        set_config_int("GAME", "sx", sx);
                        set_config_int("GAME", "sy", sy);
                        sprintf(global_string[8][5], "Screen Mode:%dx%d",sx, sy);
                        sc_setup();
                     }
               }
               if (options_menu_sel == 6) // level editor
               {
                  int old_start_level = start_level;
                  int level_editor_returned_start_level = 0;
                  int restore_start_level;
                  char fname[80];
                  final_wrapup();

                  sprintf(fname, "%spmfle.exe %d",  exe_pathandfile, start_level);
                  // printf("%s\n",fname);
                  level_editor_returned_start_level = system(fname);

                  if ((level_editor_returned_start_level > 0) && (level_editor_returned_start_level < 100))
                     restore_start_level = level_editor_returned_start_level;
                  else
                     restore_start_level = old_start_level;

                  initial_setup();

                  int p;
                  for (p=0; p<2; p++)
                  {
                     players[p].LIVES = 5;
                  }

                  set_start_level(restore_start_level);
                  play_level = start_level;
                  start_mode = 1;
                  game_exit = 0;
                  pm_main();
                  top_menu_sel = 4;
               }

            }  while (options_menu_sel != 2); // end of options menu
            rest(100);
            clear(screen);
         }

      } while (top_menu_sel != 1); // end of game menu
   }
   show_mouse(NULL);

   // redraw frame
   for (x=0;x<16;x++)
      rect(screen, x,x, SCREEN_W-1-x, SCREEN_H-1-x, 8+(x*16) );

   text_mode(-1);
   textout_centre(screen, font, "Thank you for playing Purple Martians!", SCREEN_W/2,SCREEN_H-9, 15);
   text_mode(0);

   // rest(1500);

   final_wrapup();
   exit(0);
}
END_OF_MAIN();
